%define section free

Summary:        OSGI Framework
Name:           oscar
Version:        1.0.5
Release:        1jpp
Epoch:          0
License:        BSD Style
URL:            http://oscar.objectweb.org
Group:          Development/Libraries/Application Frameworks
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        oscar-1.0.5.jar
Source1:        oscar-bundles.tar.gz
Source2:	oscar-insajmx-agent-build.xml
Source3:	oscar-insajmx-registry-build.xml
Source4:	oscar-insajmx-rmiconnector-build.xml
Source5:	oscar-insajmx-httpconnector.tar.gz

Patch0:         oscar-1.0.5-simple-build_xml.patch
Patch1:         oscar-osgi-util-build_xml.patch
Patch2:         oscar-wireadmincmd-build_xml.patch
BuildRequires:  ant >= 0:1.6, jpackage-utils >= 0:1.6
BuildRequires:  java-devel >= 0:1.5
BuildRequires:  servlet
BuildRequires:  mx4j

Requires:  xml-commons-apis
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Oscar is an open source implementation of the Open Services Gateway 
Initiative (OSGi) framework specification; the goal is to provide a 
completely compliant implementation of the OSGi framework specification. 
Oscar is currently compliant with a large portion of the OSGi 3 
specifications, although certain compliance work still needs to be 
completed. Despite this fact, the OSGi framework functionality provided 
by Oscar is very stable and is in use by many people.
Even though OSGi targets the embedded device market, the framework is 
ideally suited for experimenting with component-oriented and 
service-oriented computing in general. For example, Oscar can be 
easily embedded into other projects and used as a plugin or extension 
mechanism; it serves this purpose much better than other systems that 
are used for similar purposes, such as Java Management Extensions (JMX). 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.



%prep
%setup -c -q -n %{name}_%{version}
jar xf org/ungoverned/oscar/installer/resource/src.jar
# remove all binary libs
#find . -name "*.jar" -exec rm -f {} \;
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
mkdir oscar-bundles
(cd oscar-bundles
gzip -dc %{SOURCE1} | tar xf -
rm oscar-shellplugin-src.jar
rm oscar-tv-1.0.3-src.jar
rm oscar-upnpbasedriver-2.0.0-src.jar
)
(cd src-bundle
for j in ../oscar-bundles/*.jar; do
	jar xf $j
done
gzip -dc %{SOURCE5} | tar xf -
rm -rf osgiprov
)
cp %{SOURCE2} src-bundle/insajmx/agent/build.xml
cp %{SOURCE3} src-bundle/insajmx/registry/build.xml
cp %{SOURCE4} src-bundle/insajmx/rmiconnector/build.xml

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav

%build
rm -rf src-bundle/binarylight
rm -rf src-bundle/clock
rm -rf src-bundle/insajmx

export CLASSPATH=$(build-classpath mx4j/mx4j servlet)
ant -Dbuild.sysclasspath=first all apidoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle

install -m 644 lib/moduleloader.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/moduleloader-%{version}.jar
install -m 644 lib/oscar.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/oscar-%{version}.jar
install -m 644 lib/osgi.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/osgi-%{version}.jar
install -m 644 bundle/bundlerepository.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/bundlerepository-%{version}.jar
install -m 644 bundle/contenthandler.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/contenthandler-%{version}.jar
install -m 644 bundle/controlpoint-1.1.2-bin.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/controlpoint-%{version}.jar
install -m 644 bundle/datastreamhandler.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/datastreamhandler-%{version}.jar
install -m 644 bundle/handlertest.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/handlertest-%{version}.jar
install -m 644 bundle/httpadmin.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/httpadmin-%{version}.jar
install -m 644 bundle/httpshell.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/httpshell-%{version}.jar
install -m 644 bundle/httptest.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/httptest-%{version}.jar
install -m 644 bundle/introspector.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/introspector-%{version}.jar
install -m 644 bundle/log.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/log-%{version}.jar
install -m 644 bundle/mbeanfactory.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/mbeanfactory-%{version}.jar
install -m 644 bundle/notification.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/notification-%{version}.jar
install -m 644 bundle/osgimbean_2.0.5.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/osgimbean_2.0.5-%{version}.jar
install -m 644 bundle/osgi-service.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/osgi-service-%{version}.jar
install -m 644 bundle/osgi-util.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/osgi-util-%{version}.jar
install -m 644 bundle/PermissionAdminCommands.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/PermissionAdminCommands-%{version}.jar
install -m 644 bundle/PermissionAdmin.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/PermissionAdmin-%{version}.jar
install -m 644 bundle/permissionmanager.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/permissionmanager-%{version}.jar
install -m 644 bundle/Preferences.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/Preferences-%{version}.jar
install -m 644 bundle/remotelogger_0.1.2.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/remotelogger-%{version}.jar
install -m 644 bundle/servicebinder.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/servicebinder-%{version}.jar
install -m 644 bundle/servicelookup.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/servicelookup-%{version}.jar
install -m 644 bundle/servicenotifier.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/servicenotifier-%{version}.jar
install -m 644 bundle/serviceregister.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/serviceregister-%{version}.jar
install -m 644 bundle/servlet.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/servlet-%{version}.jar
install -m 644 bundle/shellextension.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/shellextension-%{version}.jar
install -m 644 bundle/shellextra.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/shellextra-%{version}.jar
install -m 644 bundle/shellgui.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/shellgui-%{version}.jar
install -m 644 bundle/shell.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/shell-%{version}.jar
install -m 644 bundle/shellmbean.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/shellmbean-%{version}.jar
install -m 644 bundle/shelltui.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/shelltui-%{version}.jar
install -m 644 bundle/simple.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/simple-%{version}.jar
install -m 644 bundle/tablelayout.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/tablelayout-%{version}.jar
install -m 644 bundle/telnetd.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/telnetd-%{version}.jar
install -m 644 bundle/urlhandlers.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/urlhandlers-%{version}.jar
install -m 644 bundle/wireadmincmd.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/wireadmincmd-%{version}.jar
install -m 644 bundle/xmlrpc.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle/xmlrpc-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}
%doc src-bundle/*.txt

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Tue Oct 25 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.0.5-1jpp
- First JPP release
